﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using nsoftware.IPWorksIoT;

namespace ServiceBusConsumer
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }

    private void bConnect_Click(object sender, EventArgs e)
    {
      amqp1.Reset();
      amqp1.ContainerId = tContainerId.Text;
      amqp1.RemoteHost = tHost.Text;
      amqp1.RemotePort = Convert.ToInt16(tPort.Text);
      amqp1.SSLEnabled = true;
      amqp1.AuthScheme = AmqpAuthSchemes.smSASLPlain;
      amqp1.User = tUser.Text;
      amqp1.Password = tPassword.Text;
      amqp1.Connected = true;
      amqp1.CreateSession(tSessionName.Text);
      amqp1.CreateReceiverLink(tSessionName.Text, tReceiver.Text, tTarget.Text);
    }

    private void amqp1_OnLog(object sender, AmqpLogEventArgs e)
    {
      tLog.AppendText(e.Message + "\r\n");
    }

    private void amqp1_OnConnectionStatus(object sender, AmqpConnectionStatusEventArgs e)
    {
      tLog.AppendText(e.ConnectionEvent + "\r\n");
    }

    private void amqp1_OnSSLServerAuthentication(object sender, AmqpSSLServerAuthenticationEventArgs e)
    {
      // your own logic for accepting the server's SSL certificate
      e.Accept = true;
    }

    private void amqp1_OnConnected(object sender, AmqpConnectedEventArgs e)
    {
      bConnect.Enabled = false;
      bDisconnect.Enabled = true;
    }

    private void bDisconnect_Click(object sender, EventArgs e)
    {
      bConnect.Enabled = true;
      bDisconnect.Enabled = false;
    }

    private void amqp1_OnMessageIn(object sender, AmqpMessageInEventArgs e)
    {
      tLog.AppendText("Received Message: " + e.MessageId + "\r\n");
    }
  }
}
