﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using nsoftware.IPWorksIoT;

namespace ServiceBusProducer
{
  public partial class Producer : Form
  {

    public Producer()
    {
      InitializeComponent();
    }

    private void bConnect_Click(object sender, EventArgs e)
    {
      amqp1.Reset();
      amqp1.ContainerId = tContainerId.Text;
      amqp1.RemoteHost = tHost.Text;
      amqp1.RemotePort = Convert.ToInt16(tPort.Text);
      amqp1.SSLEnabled = true;
      amqp1.AuthScheme = AmqpAuthSchemes.smSASLPlain;
      amqp1.User = tUser.Text;
      amqp1.Password = tPassword.Text;
      amqp1.Connected = true;
      amqp1.CreateSession(tSessionName.Text);
      amqp1.CreateSenderLink(tSessionName.Text, tSender.Text, tTarget.Text);
    }

    private void bSend_Click(object sender, EventArgs e)
    {
      amqp1.Message.Value = tMessage.Text;
      amqp1.SendMessage(tSender.Text);
    }

    private void amqp1_OnLog(object sender, AmqpLogEventArgs e)
    {
      tLog.AppendText(e.Message + "\r\n");
    }

    private void amqp1_OnSSLServerAuthentication(object sender, AmqpSSLServerAuthenticationEventArgs e)
    {
      // your own logic for accepting the server's SSL certificate
      e.Accept = true;
    }

    private void amqp1_OnConnectionStatus(object sender, AmqpConnectionStatusEventArgs e)
    {
      tLog.AppendText(e.ConnectionEvent + "\r\n");
    }

    private void amqp1_OnConnected(object sender, AmqpConnectedEventArgs e)
    {
      bConnect.Enabled = false;
      bDisconnect.Enabled = true;
      gSendReceive.Enabled = true;

    }

    private void bDisconnect_Click(object sender, EventArgs e)
    {
      amqp1.Disconnect();
    }

    private void amqp1_OnDisconnected(object sender, AmqpDisconnectedEventArgs e)
    {
      bConnect.Enabled = true;
      gSendReceive.Enabled = false;
      bDisconnect.Enabled = false;
    }
  }
}
